/* Copyright (C) 2013-2017 Vincent Forest (vaplv@free.fr)
 *
 * The RSys library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The RSys library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with the RSys library. If not, see <http://www.gnu.org/licenses/>. */

#define _POSIX_C_SOURCE 200112L /* ftruncate support */

#include "big_buffer.h"

#ifdef COMPILER_CL
  #include <io.h> /* _chsize support */
#else
  #include <unistd.h> /* ftruncate support */
#endif

res_T
truncate__(FILE* file, const size_t sz)
{
  ASSERT(file);
#ifdef OS_WINDOWS
  return _chsize(_fileno(file), (long)sz) == 0 ? RES_OK : RES_IO_ERR;
#else
  return ftruncate(fileno(file), (off_t)sz) == 0 ? RES_OK : RES_IO_ERR;
#endif
}

